// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: generationmodule/generationmodule.proto

package openfmb.generationmodule;

/**
 * <pre>
 * Generation real power control
 * </pre>
 *
 * Protobuf type {@code generationmodule.ReactivePowerControl}
 */
public final class ReactivePowerControl extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:generationmodule.ReactivePowerControl)
    ReactivePowerControlOrBuilder {
private static final long serialVersionUID = 0L;
  // Use ReactivePowerControl.newBuilder() to construct.
  private ReactivePowerControl(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private ReactivePowerControl() {
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new ReactivePowerControl();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.generationmodule.Generationmodule.internal_static_generationmodule_ReactivePowerControl_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.generationmodule.Generationmodule.internal_static_generationmodule_ReactivePowerControl_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.generationmodule.ReactivePowerControl.class, openfmb.generationmodule.ReactivePowerControl.Builder.class);
  }

  public static final int DROOPSETPOINT_FIELD_NUMBER = 1;
  private openfmb.generationmodule.DroopParameter droopSetpoint_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.generationmodule.DroopParameter droopSetpoint = 1;</code>
   * @return Whether the droopSetpoint field is set.
   */
  @java.lang.Override
  public boolean hasDroopSetpoint() {
    return droopSetpoint_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.generationmodule.DroopParameter droopSetpoint = 1;</code>
   * @return The droopSetpoint.
   */
  @java.lang.Override
  public openfmb.generationmodule.DroopParameter getDroopSetpoint() {
    return droopSetpoint_ == null ? openfmb.generationmodule.DroopParameter.getDefaultInstance() : droopSetpoint_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.generationmodule.DroopParameter droopSetpoint = 1;</code>
   */
  @java.lang.Override
  public openfmb.generationmodule.DroopParameterOrBuilder getDroopSetpointOrBuilder() {
    return droopSetpoint_ == null ? openfmb.generationmodule.DroopParameter.getDefaultInstance() : droopSetpoint_;
  }

  public static final int POWERFACTORSETPOINT_FIELD_NUMBER = 2;
  private com.google.protobuf.FloatValue powerFactorSetpoint_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.google.protobuf.FloatValue powerFactorSetpoint = 2;</code>
   * @return Whether the powerFactorSetpoint field is set.
   */
  @java.lang.Override
  public boolean hasPowerFactorSetpoint() {
    return powerFactorSetpoint_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.google.protobuf.FloatValue powerFactorSetpoint = 2;</code>
   * @return The powerFactorSetpoint.
   */
  @java.lang.Override
  public com.google.protobuf.FloatValue getPowerFactorSetpoint() {
    return powerFactorSetpoint_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : powerFactorSetpoint_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.google.protobuf.FloatValue powerFactorSetpoint = 2;</code>
   */
  @java.lang.Override
  public com.google.protobuf.FloatValueOrBuilder getPowerFactorSetpointOrBuilder() {
    return powerFactorSetpoint_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : powerFactorSetpoint_;
  }

  public static final int REACTIVEPOWERCONTROLMODE_FIELD_NUMBER = 3;
  private openfmb.commonmodule.Optional_ReactivePowerControlKind reactivePowerControlMode_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.Optional_ReactivePowerControlKind reactivePowerControlMode = 3;</code>
   * @return Whether the reactivePowerControlMode field is set.
   */
  @java.lang.Override
  public boolean hasReactivePowerControlMode() {
    return reactivePowerControlMode_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.Optional_ReactivePowerControlKind reactivePowerControlMode = 3;</code>
   * @return The reactivePowerControlMode.
   */
  @java.lang.Override
  public openfmb.commonmodule.Optional_ReactivePowerControlKind getReactivePowerControlMode() {
    return reactivePowerControlMode_ == null ? openfmb.commonmodule.Optional_ReactivePowerControlKind.getDefaultInstance() : reactivePowerControlMode_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.Optional_ReactivePowerControlKind reactivePowerControlMode = 3;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.Optional_ReactivePowerControlKindOrBuilder getReactivePowerControlModeOrBuilder() {
    return reactivePowerControlMode_ == null ? openfmb.commonmodule.Optional_ReactivePowerControlKind.getDefaultInstance() : reactivePowerControlMode_;
  }

  public static final int REACTIVEPOWERSETPOINT_FIELD_NUMBER = 4;
  private com.google.protobuf.FloatValue reactivePowerSetpoint_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.google.protobuf.FloatValue reactivePowerSetpoint = 4;</code>
   * @return Whether the reactivePowerSetpoint field is set.
   */
  @java.lang.Override
  public boolean hasReactivePowerSetpoint() {
    return reactivePowerSetpoint_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.google.protobuf.FloatValue reactivePowerSetpoint = 4;</code>
   * @return The reactivePowerSetpoint.
   */
  @java.lang.Override
  public com.google.protobuf.FloatValue getReactivePowerSetpoint() {
    return reactivePowerSetpoint_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : reactivePowerSetpoint_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.google.protobuf.FloatValue reactivePowerSetpoint = 4;</code>
   */
  @java.lang.Override
  public com.google.protobuf.FloatValueOrBuilder getReactivePowerSetpointOrBuilder() {
    return reactivePowerSetpoint_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : reactivePowerSetpoint_;
  }

  public static final int VOLTAGESETPOINT_FIELD_NUMBER = 5;
  private com.google.protobuf.FloatValue voltageSetpoint_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.google.protobuf.FloatValue voltageSetpoint = 5;</code>
   * @return Whether the voltageSetpoint field is set.
   */
  @java.lang.Override
  public boolean hasVoltageSetpoint() {
    return voltageSetpoint_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.google.protobuf.FloatValue voltageSetpoint = 5;</code>
   * @return The voltageSetpoint.
   */
  @java.lang.Override
  public com.google.protobuf.FloatValue getVoltageSetpoint() {
    return voltageSetpoint_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : voltageSetpoint_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.google.protobuf.FloatValue voltageSetpoint = 5;</code>
   */
  @java.lang.Override
  public com.google.protobuf.FloatValueOrBuilder getVoltageSetpointOrBuilder() {
    return voltageSetpoint_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : voltageSetpoint_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (droopSetpoint_ != null) {
      output.writeMessage(1, getDroopSetpoint());
    }
    if (powerFactorSetpoint_ != null) {
      output.writeMessage(2, getPowerFactorSetpoint());
    }
    if (reactivePowerControlMode_ != null) {
      output.writeMessage(3, getReactivePowerControlMode());
    }
    if (reactivePowerSetpoint_ != null) {
      output.writeMessage(4, getReactivePowerSetpoint());
    }
    if (voltageSetpoint_ != null) {
      output.writeMessage(5, getVoltageSetpoint());
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (droopSetpoint_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, getDroopSetpoint());
    }
    if (powerFactorSetpoint_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(2, getPowerFactorSetpoint());
    }
    if (reactivePowerControlMode_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(3, getReactivePowerControlMode());
    }
    if (reactivePowerSetpoint_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(4, getReactivePowerSetpoint());
    }
    if (voltageSetpoint_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(5, getVoltageSetpoint());
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.generationmodule.ReactivePowerControl)) {
      return super.equals(obj);
    }
    openfmb.generationmodule.ReactivePowerControl other = (openfmb.generationmodule.ReactivePowerControl) obj;

    if (hasDroopSetpoint() != other.hasDroopSetpoint()) return false;
    if (hasDroopSetpoint()) {
      if (!getDroopSetpoint()
          .equals(other.getDroopSetpoint())) return false;
    }
    if (hasPowerFactorSetpoint() != other.hasPowerFactorSetpoint()) return false;
    if (hasPowerFactorSetpoint()) {
      if (!getPowerFactorSetpoint()
          .equals(other.getPowerFactorSetpoint())) return false;
    }
    if (hasReactivePowerControlMode() != other.hasReactivePowerControlMode()) return false;
    if (hasReactivePowerControlMode()) {
      if (!getReactivePowerControlMode()
          .equals(other.getReactivePowerControlMode())) return false;
    }
    if (hasReactivePowerSetpoint() != other.hasReactivePowerSetpoint()) return false;
    if (hasReactivePowerSetpoint()) {
      if (!getReactivePowerSetpoint()
          .equals(other.getReactivePowerSetpoint())) return false;
    }
    if (hasVoltageSetpoint() != other.hasVoltageSetpoint()) return false;
    if (hasVoltageSetpoint()) {
      if (!getVoltageSetpoint()
          .equals(other.getVoltageSetpoint())) return false;
    }
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (hasDroopSetpoint()) {
      hash = (37 * hash) + DROOPSETPOINT_FIELD_NUMBER;
      hash = (53 * hash) + getDroopSetpoint().hashCode();
    }
    if (hasPowerFactorSetpoint()) {
      hash = (37 * hash) + POWERFACTORSETPOINT_FIELD_NUMBER;
      hash = (53 * hash) + getPowerFactorSetpoint().hashCode();
    }
    if (hasReactivePowerControlMode()) {
      hash = (37 * hash) + REACTIVEPOWERCONTROLMODE_FIELD_NUMBER;
      hash = (53 * hash) + getReactivePowerControlMode().hashCode();
    }
    if (hasReactivePowerSetpoint()) {
      hash = (37 * hash) + REACTIVEPOWERSETPOINT_FIELD_NUMBER;
      hash = (53 * hash) + getReactivePowerSetpoint().hashCode();
    }
    if (hasVoltageSetpoint()) {
      hash = (37 * hash) + VOLTAGESETPOINT_FIELD_NUMBER;
      hash = (53 * hash) + getVoltageSetpoint().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.generationmodule.ReactivePowerControl parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.generationmodule.ReactivePowerControl parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.generationmodule.ReactivePowerControl parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.generationmodule.ReactivePowerControl parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.generationmodule.ReactivePowerControl parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.generationmodule.ReactivePowerControl parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.generationmodule.ReactivePowerControl parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.generationmodule.ReactivePowerControl parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.generationmodule.ReactivePowerControl parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.generationmodule.ReactivePowerControl parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.generationmodule.ReactivePowerControl parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.generationmodule.ReactivePowerControl parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.generationmodule.ReactivePowerControl prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * Generation real power control
   * </pre>
   *
   * Protobuf type {@code generationmodule.ReactivePowerControl}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:generationmodule.ReactivePowerControl)
      openfmb.generationmodule.ReactivePowerControlOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.generationmodule.Generationmodule.internal_static_generationmodule_ReactivePowerControl_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.generationmodule.Generationmodule.internal_static_generationmodule_ReactivePowerControl_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.generationmodule.ReactivePowerControl.class, openfmb.generationmodule.ReactivePowerControl.Builder.class);
    }

    // Construct using openfmb.generationmodule.ReactivePowerControl.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      droopSetpoint_ = null;
      if (droopSetpointBuilder_ != null) {
        droopSetpointBuilder_.dispose();
        droopSetpointBuilder_ = null;
      }
      powerFactorSetpoint_ = null;
      if (powerFactorSetpointBuilder_ != null) {
        powerFactorSetpointBuilder_.dispose();
        powerFactorSetpointBuilder_ = null;
      }
      reactivePowerControlMode_ = null;
      if (reactivePowerControlModeBuilder_ != null) {
        reactivePowerControlModeBuilder_.dispose();
        reactivePowerControlModeBuilder_ = null;
      }
      reactivePowerSetpoint_ = null;
      if (reactivePowerSetpointBuilder_ != null) {
        reactivePowerSetpointBuilder_.dispose();
        reactivePowerSetpointBuilder_ = null;
      }
      voltageSetpoint_ = null;
      if (voltageSetpointBuilder_ != null) {
        voltageSetpointBuilder_.dispose();
        voltageSetpointBuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.generationmodule.Generationmodule.internal_static_generationmodule_ReactivePowerControl_descriptor;
    }

    @java.lang.Override
    public openfmb.generationmodule.ReactivePowerControl getDefaultInstanceForType() {
      return openfmb.generationmodule.ReactivePowerControl.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.generationmodule.ReactivePowerControl build() {
      openfmb.generationmodule.ReactivePowerControl result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.generationmodule.ReactivePowerControl buildPartial() {
      openfmb.generationmodule.ReactivePowerControl result = new openfmb.generationmodule.ReactivePowerControl(this);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartial0(openfmb.generationmodule.ReactivePowerControl result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.droopSetpoint_ = droopSetpointBuilder_ == null
            ? droopSetpoint_
            : droopSetpointBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.powerFactorSetpoint_ = powerFactorSetpointBuilder_ == null
            ? powerFactorSetpoint_
            : powerFactorSetpointBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000004) != 0)) {
        result.reactivePowerControlMode_ = reactivePowerControlModeBuilder_ == null
            ? reactivePowerControlMode_
            : reactivePowerControlModeBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000008) != 0)) {
        result.reactivePowerSetpoint_ = reactivePowerSetpointBuilder_ == null
            ? reactivePowerSetpoint_
            : reactivePowerSetpointBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000010) != 0)) {
        result.voltageSetpoint_ = voltageSetpointBuilder_ == null
            ? voltageSetpoint_
            : voltageSetpointBuilder_.build();
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.generationmodule.ReactivePowerControl) {
        return mergeFrom((openfmb.generationmodule.ReactivePowerControl)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.generationmodule.ReactivePowerControl other) {
      if (other == openfmb.generationmodule.ReactivePowerControl.getDefaultInstance()) return this;
      if (other.hasDroopSetpoint()) {
        mergeDroopSetpoint(other.getDroopSetpoint());
      }
      if (other.hasPowerFactorSetpoint()) {
        mergePowerFactorSetpoint(other.getPowerFactorSetpoint());
      }
      if (other.hasReactivePowerControlMode()) {
        mergeReactivePowerControlMode(other.getReactivePowerControlMode());
      }
      if (other.hasReactivePowerSetpoint()) {
        mergeReactivePowerSetpoint(other.getReactivePowerSetpoint());
      }
      if (other.hasVoltageSetpoint()) {
        mergeVoltageSetpoint(other.getVoltageSetpoint());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              input.readMessage(
                  getDroopSetpointFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000001;
              break;
            } // case 10
            case 18: {
              input.readMessage(
                  getPowerFactorSetpointFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000002;
              break;
            } // case 18
            case 26: {
              input.readMessage(
                  getReactivePowerControlModeFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000004;
              break;
            } // case 26
            case 34: {
              input.readMessage(
                  getReactivePowerSetpointFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000008;
              break;
            } // case 34
            case 42: {
              input.readMessage(
                  getVoltageSetpointFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000010;
              break;
            } // case 42
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private openfmb.generationmodule.DroopParameter droopSetpoint_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.generationmodule.DroopParameter, openfmb.generationmodule.DroopParameter.Builder, openfmb.generationmodule.DroopParameterOrBuilder> droopSetpointBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.generationmodule.DroopParameter droopSetpoint = 1;</code>
     * @return Whether the droopSetpoint field is set.
     */
    public boolean hasDroopSetpoint() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.generationmodule.DroopParameter droopSetpoint = 1;</code>
     * @return The droopSetpoint.
     */
    public openfmb.generationmodule.DroopParameter getDroopSetpoint() {
      if (droopSetpointBuilder_ == null) {
        return droopSetpoint_ == null ? openfmb.generationmodule.DroopParameter.getDefaultInstance() : droopSetpoint_;
      } else {
        return droopSetpointBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.generationmodule.DroopParameter droopSetpoint = 1;</code>
     */
    public Builder setDroopSetpoint(openfmb.generationmodule.DroopParameter value) {
      if (droopSetpointBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        droopSetpoint_ = value;
      } else {
        droopSetpointBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.generationmodule.DroopParameter droopSetpoint = 1;</code>
     */
    public Builder setDroopSetpoint(
        openfmb.generationmodule.DroopParameter.Builder builderForValue) {
      if (droopSetpointBuilder_ == null) {
        droopSetpoint_ = builderForValue.build();
      } else {
        droopSetpointBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.generationmodule.DroopParameter droopSetpoint = 1;</code>
     */
    public Builder mergeDroopSetpoint(openfmb.generationmodule.DroopParameter value) {
      if (droopSetpointBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0) &&
          droopSetpoint_ != null &&
          droopSetpoint_ != openfmb.generationmodule.DroopParameter.getDefaultInstance()) {
          getDroopSetpointBuilder().mergeFrom(value);
        } else {
          droopSetpoint_ = value;
        }
      } else {
        droopSetpointBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.generationmodule.DroopParameter droopSetpoint = 1;</code>
     */
    public Builder clearDroopSetpoint() {
      bitField0_ = (bitField0_ & ~0x00000001);
      droopSetpoint_ = null;
      if (droopSetpointBuilder_ != null) {
        droopSetpointBuilder_.dispose();
        droopSetpointBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.generationmodule.DroopParameter droopSetpoint = 1;</code>
     */
    public openfmb.generationmodule.DroopParameter.Builder getDroopSetpointBuilder() {
      bitField0_ |= 0x00000001;
      onChanged();
      return getDroopSetpointFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.generationmodule.DroopParameter droopSetpoint = 1;</code>
     */
    public openfmb.generationmodule.DroopParameterOrBuilder getDroopSetpointOrBuilder() {
      if (droopSetpointBuilder_ != null) {
        return droopSetpointBuilder_.getMessageOrBuilder();
      } else {
        return droopSetpoint_ == null ?
            openfmb.generationmodule.DroopParameter.getDefaultInstance() : droopSetpoint_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.generationmodule.DroopParameter droopSetpoint = 1;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.generationmodule.DroopParameter, openfmb.generationmodule.DroopParameter.Builder, openfmb.generationmodule.DroopParameterOrBuilder> 
        getDroopSetpointFieldBuilder() {
      if (droopSetpointBuilder_ == null) {
        droopSetpointBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.generationmodule.DroopParameter, openfmb.generationmodule.DroopParameter.Builder, openfmb.generationmodule.DroopParameterOrBuilder>(
                getDroopSetpoint(),
                getParentForChildren(),
                isClean());
        droopSetpoint_ = null;
      }
      return droopSetpointBuilder_;
    }

    private com.google.protobuf.FloatValue powerFactorSetpoint_;
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> powerFactorSetpointBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue powerFactorSetpoint = 2;</code>
     * @return Whether the powerFactorSetpoint field is set.
     */
    public boolean hasPowerFactorSetpoint() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue powerFactorSetpoint = 2;</code>
     * @return The powerFactorSetpoint.
     */
    public com.google.protobuf.FloatValue getPowerFactorSetpoint() {
      if (powerFactorSetpointBuilder_ == null) {
        return powerFactorSetpoint_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : powerFactorSetpoint_;
      } else {
        return powerFactorSetpointBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue powerFactorSetpoint = 2;</code>
     */
    public Builder setPowerFactorSetpoint(com.google.protobuf.FloatValue value) {
      if (powerFactorSetpointBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        powerFactorSetpoint_ = value;
      } else {
        powerFactorSetpointBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue powerFactorSetpoint = 2;</code>
     */
    public Builder setPowerFactorSetpoint(
        com.google.protobuf.FloatValue.Builder builderForValue) {
      if (powerFactorSetpointBuilder_ == null) {
        powerFactorSetpoint_ = builderForValue.build();
      } else {
        powerFactorSetpointBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue powerFactorSetpoint = 2;</code>
     */
    public Builder mergePowerFactorSetpoint(com.google.protobuf.FloatValue value) {
      if (powerFactorSetpointBuilder_ == null) {
        if (((bitField0_ & 0x00000002) != 0) &&
          powerFactorSetpoint_ != null &&
          powerFactorSetpoint_ != com.google.protobuf.FloatValue.getDefaultInstance()) {
          getPowerFactorSetpointBuilder().mergeFrom(value);
        } else {
          powerFactorSetpoint_ = value;
        }
      } else {
        powerFactorSetpointBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue powerFactorSetpoint = 2;</code>
     */
    public Builder clearPowerFactorSetpoint() {
      bitField0_ = (bitField0_ & ~0x00000002);
      powerFactorSetpoint_ = null;
      if (powerFactorSetpointBuilder_ != null) {
        powerFactorSetpointBuilder_.dispose();
        powerFactorSetpointBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue powerFactorSetpoint = 2;</code>
     */
    public com.google.protobuf.FloatValue.Builder getPowerFactorSetpointBuilder() {
      bitField0_ |= 0x00000002;
      onChanged();
      return getPowerFactorSetpointFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue powerFactorSetpoint = 2;</code>
     */
    public com.google.protobuf.FloatValueOrBuilder getPowerFactorSetpointOrBuilder() {
      if (powerFactorSetpointBuilder_ != null) {
        return powerFactorSetpointBuilder_.getMessageOrBuilder();
      } else {
        return powerFactorSetpoint_ == null ?
            com.google.protobuf.FloatValue.getDefaultInstance() : powerFactorSetpoint_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue powerFactorSetpoint = 2;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> 
        getPowerFactorSetpointFieldBuilder() {
      if (powerFactorSetpointBuilder_ == null) {
        powerFactorSetpointBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder>(
                getPowerFactorSetpoint(),
                getParentForChildren(),
                isClean());
        powerFactorSetpoint_ = null;
      }
      return powerFactorSetpointBuilder_;
    }

    private openfmb.commonmodule.Optional_ReactivePowerControlKind reactivePowerControlMode_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.Optional_ReactivePowerControlKind, openfmb.commonmodule.Optional_ReactivePowerControlKind.Builder, openfmb.commonmodule.Optional_ReactivePowerControlKindOrBuilder> reactivePowerControlModeBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.Optional_ReactivePowerControlKind reactivePowerControlMode = 3;</code>
     * @return Whether the reactivePowerControlMode field is set.
     */
    public boolean hasReactivePowerControlMode() {
      return ((bitField0_ & 0x00000004) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.Optional_ReactivePowerControlKind reactivePowerControlMode = 3;</code>
     * @return The reactivePowerControlMode.
     */
    public openfmb.commonmodule.Optional_ReactivePowerControlKind getReactivePowerControlMode() {
      if (reactivePowerControlModeBuilder_ == null) {
        return reactivePowerControlMode_ == null ? openfmb.commonmodule.Optional_ReactivePowerControlKind.getDefaultInstance() : reactivePowerControlMode_;
      } else {
        return reactivePowerControlModeBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.Optional_ReactivePowerControlKind reactivePowerControlMode = 3;</code>
     */
    public Builder setReactivePowerControlMode(openfmb.commonmodule.Optional_ReactivePowerControlKind value) {
      if (reactivePowerControlModeBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        reactivePowerControlMode_ = value;
      } else {
        reactivePowerControlModeBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.Optional_ReactivePowerControlKind reactivePowerControlMode = 3;</code>
     */
    public Builder setReactivePowerControlMode(
        openfmb.commonmodule.Optional_ReactivePowerControlKind.Builder builderForValue) {
      if (reactivePowerControlModeBuilder_ == null) {
        reactivePowerControlMode_ = builderForValue.build();
      } else {
        reactivePowerControlModeBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.Optional_ReactivePowerControlKind reactivePowerControlMode = 3;</code>
     */
    public Builder mergeReactivePowerControlMode(openfmb.commonmodule.Optional_ReactivePowerControlKind value) {
      if (reactivePowerControlModeBuilder_ == null) {
        if (((bitField0_ & 0x00000004) != 0) &&
          reactivePowerControlMode_ != null &&
          reactivePowerControlMode_ != openfmb.commonmodule.Optional_ReactivePowerControlKind.getDefaultInstance()) {
          getReactivePowerControlModeBuilder().mergeFrom(value);
        } else {
          reactivePowerControlMode_ = value;
        }
      } else {
        reactivePowerControlModeBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.Optional_ReactivePowerControlKind reactivePowerControlMode = 3;</code>
     */
    public Builder clearReactivePowerControlMode() {
      bitField0_ = (bitField0_ & ~0x00000004);
      reactivePowerControlMode_ = null;
      if (reactivePowerControlModeBuilder_ != null) {
        reactivePowerControlModeBuilder_.dispose();
        reactivePowerControlModeBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.Optional_ReactivePowerControlKind reactivePowerControlMode = 3;</code>
     */
    public openfmb.commonmodule.Optional_ReactivePowerControlKind.Builder getReactivePowerControlModeBuilder() {
      bitField0_ |= 0x00000004;
      onChanged();
      return getReactivePowerControlModeFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.Optional_ReactivePowerControlKind reactivePowerControlMode = 3;</code>
     */
    public openfmb.commonmodule.Optional_ReactivePowerControlKindOrBuilder getReactivePowerControlModeOrBuilder() {
      if (reactivePowerControlModeBuilder_ != null) {
        return reactivePowerControlModeBuilder_.getMessageOrBuilder();
      } else {
        return reactivePowerControlMode_ == null ?
            openfmb.commonmodule.Optional_ReactivePowerControlKind.getDefaultInstance() : reactivePowerControlMode_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.Optional_ReactivePowerControlKind reactivePowerControlMode = 3;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.Optional_ReactivePowerControlKind, openfmb.commonmodule.Optional_ReactivePowerControlKind.Builder, openfmb.commonmodule.Optional_ReactivePowerControlKindOrBuilder> 
        getReactivePowerControlModeFieldBuilder() {
      if (reactivePowerControlModeBuilder_ == null) {
        reactivePowerControlModeBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.Optional_ReactivePowerControlKind, openfmb.commonmodule.Optional_ReactivePowerControlKind.Builder, openfmb.commonmodule.Optional_ReactivePowerControlKindOrBuilder>(
                getReactivePowerControlMode(),
                getParentForChildren(),
                isClean());
        reactivePowerControlMode_ = null;
      }
      return reactivePowerControlModeBuilder_;
    }

    private com.google.protobuf.FloatValue reactivePowerSetpoint_;
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> reactivePowerSetpointBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue reactivePowerSetpoint = 4;</code>
     * @return Whether the reactivePowerSetpoint field is set.
     */
    public boolean hasReactivePowerSetpoint() {
      return ((bitField0_ & 0x00000008) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue reactivePowerSetpoint = 4;</code>
     * @return The reactivePowerSetpoint.
     */
    public com.google.protobuf.FloatValue getReactivePowerSetpoint() {
      if (reactivePowerSetpointBuilder_ == null) {
        return reactivePowerSetpoint_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : reactivePowerSetpoint_;
      } else {
        return reactivePowerSetpointBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue reactivePowerSetpoint = 4;</code>
     */
    public Builder setReactivePowerSetpoint(com.google.protobuf.FloatValue value) {
      if (reactivePowerSetpointBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        reactivePowerSetpoint_ = value;
      } else {
        reactivePowerSetpointBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue reactivePowerSetpoint = 4;</code>
     */
    public Builder setReactivePowerSetpoint(
        com.google.protobuf.FloatValue.Builder builderForValue) {
      if (reactivePowerSetpointBuilder_ == null) {
        reactivePowerSetpoint_ = builderForValue.build();
      } else {
        reactivePowerSetpointBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue reactivePowerSetpoint = 4;</code>
     */
    public Builder mergeReactivePowerSetpoint(com.google.protobuf.FloatValue value) {
      if (reactivePowerSetpointBuilder_ == null) {
        if (((bitField0_ & 0x00000008) != 0) &&
          reactivePowerSetpoint_ != null &&
          reactivePowerSetpoint_ != com.google.protobuf.FloatValue.getDefaultInstance()) {
          getReactivePowerSetpointBuilder().mergeFrom(value);
        } else {
          reactivePowerSetpoint_ = value;
        }
      } else {
        reactivePowerSetpointBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue reactivePowerSetpoint = 4;</code>
     */
    public Builder clearReactivePowerSetpoint() {
      bitField0_ = (bitField0_ & ~0x00000008);
      reactivePowerSetpoint_ = null;
      if (reactivePowerSetpointBuilder_ != null) {
        reactivePowerSetpointBuilder_.dispose();
        reactivePowerSetpointBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue reactivePowerSetpoint = 4;</code>
     */
    public com.google.protobuf.FloatValue.Builder getReactivePowerSetpointBuilder() {
      bitField0_ |= 0x00000008;
      onChanged();
      return getReactivePowerSetpointFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue reactivePowerSetpoint = 4;</code>
     */
    public com.google.protobuf.FloatValueOrBuilder getReactivePowerSetpointOrBuilder() {
      if (reactivePowerSetpointBuilder_ != null) {
        return reactivePowerSetpointBuilder_.getMessageOrBuilder();
      } else {
        return reactivePowerSetpoint_ == null ?
            com.google.protobuf.FloatValue.getDefaultInstance() : reactivePowerSetpoint_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue reactivePowerSetpoint = 4;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> 
        getReactivePowerSetpointFieldBuilder() {
      if (reactivePowerSetpointBuilder_ == null) {
        reactivePowerSetpointBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder>(
                getReactivePowerSetpoint(),
                getParentForChildren(),
                isClean());
        reactivePowerSetpoint_ = null;
      }
      return reactivePowerSetpointBuilder_;
    }

    private com.google.protobuf.FloatValue voltageSetpoint_;
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> voltageSetpointBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue voltageSetpoint = 5;</code>
     * @return Whether the voltageSetpoint field is set.
     */
    public boolean hasVoltageSetpoint() {
      return ((bitField0_ & 0x00000010) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue voltageSetpoint = 5;</code>
     * @return The voltageSetpoint.
     */
    public com.google.protobuf.FloatValue getVoltageSetpoint() {
      if (voltageSetpointBuilder_ == null) {
        return voltageSetpoint_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : voltageSetpoint_;
      } else {
        return voltageSetpointBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue voltageSetpoint = 5;</code>
     */
    public Builder setVoltageSetpoint(com.google.protobuf.FloatValue value) {
      if (voltageSetpointBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        voltageSetpoint_ = value;
      } else {
        voltageSetpointBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000010;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue voltageSetpoint = 5;</code>
     */
    public Builder setVoltageSetpoint(
        com.google.protobuf.FloatValue.Builder builderForValue) {
      if (voltageSetpointBuilder_ == null) {
        voltageSetpoint_ = builderForValue.build();
      } else {
        voltageSetpointBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000010;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue voltageSetpoint = 5;</code>
     */
    public Builder mergeVoltageSetpoint(com.google.protobuf.FloatValue value) {
      if (voltageSetpointBuilder_ == null) {
        if (((bitField0_ & 0x00000010) != 0) &&
          voltageSetpoint_ != null &&
          voltageSetpoint_ != com.google.protobuf.FloatValue.getDefaultInstance()) {
          getVoltageSetpointBuilder().mergeFrom(value);
        } else {
          voltageSetpoint_ = value;
        }
      } else {
        voltageSetpointBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000010;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue voltageSetpoint = 5;</code>
     */
    public Builder clearVoltageSetpoint() {
      bitField0_ = (bitField0_ & ~0x00000010);
      voltageSetpoint_ = null;
      if (voltageSetpointBuilder_ != null) {
        voltageSetpointBuilder_.dispose();
        voltageSetpointBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue voltageSetpoint = 5;</code>
     */
    public com.google.protobuf.FloatValue.Builder getVoltageSetpointBuilder() {
      bitField0_ |= 0x00000010;
      onChanged();
      return getVoltageSetpointFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue voltageSetpoint = 5;</code>
     */
    public com.google.protobuf.FloatValueOrBuilder getVoltageSetpointOrBuilder() {
      if (voltageSetpointBuilder_ != null) {
        return voltageSetpointBuilder_.getMessageOrBuilder();
      } else {
        return voltageSetpoint_ == null ?
            com.google.protobuf.FloatValue.getDefaultInstance() : voltageSetpoint_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue voltageSetpoint = 5;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> 
        getVoltageSetpointFieldBuilder() {
      if (voltageSetpointBuilder_ == null) {
        voltageSetpointBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder>(
                getVoltageSetpoint(),
                getParentForChildren(),
                isClean());
        voltageSetpoint_ = null;
      }
      return voltageSetpointBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:generationmodule.ReactivePowerControl)
  }

  // @@protoc_insertion_point(class_scope:generationmodule.ReactivePowerControl)
  private static final openfmb.generationmodule.ReactivePowerControl DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.generationmodule.ReactivePowerControl();
  }

  public static openfmb.generationmodule.ReactivePowerControl getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<ReactivePowerControl>
      PARSER = new com.google.protobuf.AbstractParser<ReactivePowerControl>() {
    @java.lang.Override
    public ReactivePowerControl parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<ReactivePowerControl> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<ReactivePowerControl> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.generationmodule.ReactivePowerControl getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

